﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Configuration;

namespace WebApplication2
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                // This is WMK, it's working when resize.
                //Button1_Click(null, new EventArgs());

                // This is VE, it doesn't work when resize, the overlay will displace.
                Button2_Click(null, new EventArgs());
            }
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            Map1.CustomOverlays.Clear();
            Map1.CurrentExtent = new RectangleShape(-101.809588203125, 35.3254938476562, -101.458712348633, 35.1373529785156);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            WorldMapKitWmsWebOverlay overlay = new WorldMapKitWmsWebOverlay();
            Map1.CustomOverlays.Add(overlay);


            LayerOverlay evacuationRouteOverlay = new LayerOverlay("EvacuationRouteOverlay");
            evacuationRouteOverlay.IsBaseOverlay = false;
            ShapeFileFeatureLayer evacuationRouteLayer = new ShapeFileFeatureLayer(MapPath("/App_Data/Rte_arrows.shp"));

            evacuationRouteLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.StandardColors.Black, 4));
            evacuationRouteLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            evacuationRouteOverlay.Layers.Add(evacuationRouteLayer);
            Map1.CustomOverlays.Add(evacuationRouteOverlay);
        }

        protected void Button2_Click(object sender, EventArgs e)
        {
            Map1.CustomOverlays.Clear();

            Map1.CurrentExtent = new RectangleShape(-11336261.007852, 4214661.3020288, -11287341.309758, 4177971.5284584);
            Map1.MapUnit = GeographyUnit.Meter;

            VirtualEarthOverlay ve = new VirtualEarthOverlay("VirtualEarth Map");
            ve.JavaScriptLibraryUri = new Uri(ConfigurationManager.AppSettings["VEUri"]);
            ve.VirtualEarthMapType = ThinkGeo.MapSuite.WebEdition.VirtualEarthMapType.Road;
            Map1.CustomOverlays.Add(ve);   

            Proj4Projection projection = new Proj4Projection();
            projection.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
            projection.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();

            LayerOverlay evacuationRouteOverlay = new LayerOverlay("EvacuationRouteOverlay");
            evacuationRouteOverlay.IsBaseOverlay = false;
            ShapeFileFeatureLayer evacuationRouteLayer = new ShapeFileFeatureLayer(MapPath("/App_Data/Rte_arrows.shp"));
            evacuationRouteLayer.FeatureSource.Projection = projection;
            evacuationRouteLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.StandardColors.Black, 4));
            evacuationRouteLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            evacuationRouteOverlay.Layers.Add(evacuationRouteLayer);
            Map1.CustomOverlays.Add(evacuationRouteOverlay);
        }
    }
}
